(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("path"), require("body-parser"), require("child_process"), require("crypto"), require("express"), require("fs"), require("mkdirp"), require("multer"), require("socket.io"), require("socket.io-client"));
	else if(typeof define === 'function' && define.amd)
		define("starboard", ["path", "body-parser", "child_process", "crypto", "express", "fs", "mkdirp", "multer", "socket.io", "socket.io-client"], factory);
	else if(typeof exports === 'object')
		exports["starboard"] = factory(require("path"), require("body-parser"), require("child_process"), require("crypto"), require("express"), require("fs"), require("mkdirp"), require("multer"), require("socket.io"), require("socket.io-client"));
	else
		root["starboard"] = factory(root["path"], root["body-parser"], root["child_process"], root["crypto"], root["express"], root["fs"], root["mkdirp"], root["multer"], root["socket.io"], root["socket.io-client"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_5__, __WEBPACK_EXTERNAL_MODULE_40__, __WEBPACK_EXTERNAL_MODULE_41__, __WEBPACK_EXTERNAL_MODULE_42__, __WEBPACK_EXTERNAL_MODULE_43__, __WEBPACK_EXTERNAL_MODULE_44__, __WEBPACK_EXTERNAL_MODULE_45__, __WEBPACK_EXTERNAL_MODULE_46__, __WEBPACK_EXTERNAL_MODULE_47__, __WEBPACK_EXTERNAL_MODULE_48__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 23);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.userUpdatedEventType = exports.settingsUpdatedEventType = exports.fileRemovedEventType = exports.fileAddedEventType = exports.commentRemovedEventType = exports.commentAddedEventType = exports.columnRemovedEventType = exports.columnUpdatedEventType = exports.columnAddedEventType = exports.cardRemovedEventType = exports.cardMemberUpdatedEventType = exports.cardLabelUpdatedEventType = exports.cardUpdatedEventType = exports.cardAddedEventType = exports.permissionDeniedEventType = exports.noopEventType = undefined;
exports.noopEvent = noopEvent;
exports.permissionDeniedEvent = permissionDeniedEvent;
exports.cardAddedEvent = cardAddedEvent;
exports.cardUpdatedEvent = cardUpdatedEvent;
exports.cardLabelUpdatedEvent = cardLabelUpdatedEvent;
exports.cardMemberUpdatedEvent = cardMemberUpdatedEvent;
exports.cardRemovedEvent = cardRemovedEvent;
exports.columnAddedEvent = columnAddedEvent;
exports.columnUpdatedEvent = columnUpdatedEvent;
exports.columnRemovedEvent = columnRemovedEvent;
exports.commentAddedEvent = commentAddedEvent;
exports.commentRemovedEvent = commentRemovedEvent;
exports.fileAddedEvent = fileAddedEvent;
exports.fileRemovedEvent = fileRemovedEvent;
exports.settingsUpdatedEvent = settingsUpdatedEvent;
exports.userUpdatedEvent = userUpdatedEvent;

var _v = __webpack_require__(9);

var _v2 = _interopRequireDefault(_v);

var _utils = __webpack_require__(1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var noopEventType = exports.noopEventType = 'NOOP';
function noopEvent() {
  var description = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

  var event = {
    type: noopEventType,
    id: (0, _v2.default)()
  };
  if (description) event.description = description;
  return event;
}

var permissionDeniedEventType = exports.permissionDeniedEventType = 'PERMISSION_DENIED';
function permissionDeniedEvent(originalEvent) {
  return {
    type: permissionDeniedEventType,
    originalEvent: originalEvent,
    id: (0, _v2.default)()
  };
}

var cardAddedEventType = exports.cardAddedEventType = 'CARD_ADDED';
function cardAddedEvent(requesterId, params) {
  var columnId = params.columnId,
      position = params.position,
      title = params.title;

  return {
    type: cardAddedEventType,
    data: {
      id: (0, _v2.default)(),
      columnId: columnId,
      position: position,
      title: title,
      description: ''
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var cardUpdatedEventType = exports.cardUpdatedEventType = 'CARD_UPDATED';
function cardUpdatedEvent(requesterId, cardId, changes) {
  return {
    type: cardUpdatedEventType,
    data: {
      cardId: cardId,
      changes: changes
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var cardLabelUpdatedEventType = exports.cardLabelUpdatedEventType = 'CARD_LABEL_UPDATED';
function cardLabelUpdatedEvent(requesterId, cardId, label, shouldBeSet) {
  return {
    type: cardLabelUpdatedEventType,
    data: {
      cardId: cardId,
      label: label,
      set: shouldBeSet
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var cardMemberUpdatedEventType = exports.cardMemberUpdatedEventType = 'CARD_MEMBER_UPDATED';
function cardMemberUpdatedEvent(requesterId, cardId, userId, shouldBeSet) {
  return {
    type: cardMemberUpdatedEventType,
    data: {
      cardId: cardId,
      userId: userId,
      set: shouldBeSet
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var cardRemovedEventType = exports.cardRemovedEventType = 'CARD_REMOVED';
function cardRemovedEvent(requesterId, cardId) {
  return {
    type: cardRemovedEventType,
    data: { cardId: cardId },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var columnAddedEventType = exports.columnAddedEventType = 'COLUMN_ADDED';
function columnAddedEvent(requesterId, params) {
  var name = params.name,
      position = params.position;

  return {
    type: columnAddedEventType,
    data: {
      id: (0, _v2.default)(),
      name: name,
      position: position
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var columnUpdatedEventType = exports.columnUpdatedEventType = 'COLUMN_UPDATED';
function columnUpdatedEvent(requesterId, columnId, changes) {
  return {
    type: columnUpdatedEventType,
    data: {
      columnId: columnId,
      changes: changes
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var columnRemovedEventType = exports.columnRemovedEventType = 'COLUMN_REMOVED';
function columnRemovedEvent(requesterId, columnId) {
  return {
    type: columnRemovedEventType,
    data: {
      columnId: columnId
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var commentAddedEventType = exports.commentAddedEventType = 'COMMENT_ADDED';
function commentAddedEvent(requesterId, cardId, params) {
  var content = params.content,
      attachmentName = params.attachmentName,
      attachmentSize = params.attachmentSize,
      attachmentType = params.attachmentType,
      attachmentUrl = params.attachmentUrl;


  var attachment = null;
  if (attachmentName) {
    attachment = {
      name: attachmentName,
      size: attachmentSize,
      type: attachmentType,
      dataUrl: attachmentUrl
    };
  }

  return {
    type: commentAddedEventType,
    data: {
      id: (0, _v2.default)(),
      cardId: cardId,
      content: content,
      attachment: attachment,
      authorId: requesterId
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var commentRemovedEventType = exports.commentRemovedEventType = 'COMMENT_REMOVED';
function commentRemovedEvent(requesterId, commentId) {
  return {
    type: commentRemovedEventType,
    data: { commentId: commentId },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var fileAddedEventType = exports.fileAddedEventType = 'FILE_ADDED';
function fileAddedEvent(requesterId, filePath) {
  return {
    type: fileAddedEventType,
    data: {
      filePath: filePath
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var fileRemovedEventType = exports.fileRemovedEventType = 'FILE_REMOVED';
function fileRemovedEvent(requesterId, filePath) {
  return {
    type: fileRemovedEventType,
    data: {
      filePath: filePath
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var settingsUpdatedEventType = exports.settingsUpdatedEventType = 'SETTINGS_UPDATED';
function settingsUpdatedEvent(requesterId, key, value) {
  return {
    type: settingsUpdatedEventType,
    data: {
      id: key,
      value: value
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

var userUpdatedEventType = exports.userUpdatedEventType = 'USER_UPDATED';
function userUpdatedEvent(requesterId, userId, key, value) {
  return {
    type: userUpdatedEventType,
    data: {
      id: userId,
      key: key,
      value: value
    },
    createdAt: (0, _utils.currentTimestamp)(),
    requesterId: requesterId,
    id: (0, _v2.default)()
  };
}

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.currentTimestamp = currentTimestamp;
exports.formattedDate = formattedDate;
exports.hasToBeSet = hasToBeSet;
function currentTimestamp() {
  return Math.floor(Date.now() / 1000);
}

function formattedDate(timestamp) {
  if (!timestamp) return '';

  function pad(x) {
    return ('0' + x).slice(-2);
  }

  var d = new Date(timestamp * 1000);
  var hours = pad(d.getHours());
  var minutes = pad(d.getMinutes());
  var seconds = pad(d.getSeconds());
  var day = pad(d.getDate());
  var month = pad(d.getMonth() + 1);
  var year = pad(d.getYear());
  return hours + ':' + minutes + ':' + seconds + ' ' + day + '/' + month + '/' + year;
}

function hasToBeSet(key) {
  throw new Error(key + ' has to be set');
}

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NullLogger = function () {
  function NullLogger() {
    _classCallCheck(this, NullLogger);
  }

  _createClass(NullLogger, [{
    key: "log",
    value: function log() {}
  }]);

  return NullLogger;
}();

exports.default = NullLogger;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CardsRepository = function () {
  function CardsRepository(stateManager) {
    _classCallCheck(this, CardsRepository);

    this.stateManager = stateManager;
  }

  _createClass(CardsRepository, [{
    key: 'get',
    value: function get(id) {
      var bucket = this.stateManager.bucket('cards');
      return bucket.filter(function (c) {
        return c.id === id;
      })[0];
    }
  }, {
    key: 'cardExists',
    value: function cardExists(id) {
      return !!this.get(id);
    }
  }, {
    key: 'cardsByColumn',
    value: function cardsByColumn(columnId) {
      var bucket = this.stateManager.bucket('cards');
      return bucket.filter(function (c) {
        return c.columnId === columnId;
      });
    }
  }, {
    key: 'cardsSortedByPosition',
    value: function cardsSortedByPosition(columnId) {
      return this.cardsByColumn(columnId).sort(function (c1, c2) {
        return c1.position - c2.position;
      });
    }
  }, {
    key: 'addCard',
    value: function addCard(title, columnId) {
      var requesterId = this.stateManager.getUserId();
      var lastCard = this.cardsSortedByPosition(columnId).reverse()[0] || { position: -1 };
      var lastPosition = lastCard.position + 1;

      var event = (0, _eventDefinitions.cardAddedEvent)(requesterId, {
        columnId: columnId,
        position: lastPosition,
        title: title
      });
      return this.stateManager.addEvent(event);
    }
  }, {
    key: 'updateCard',
    value: function updateCard(id, changes) {
      var requesterId = this.stateManager.getUserId();
      var event = (0, _eventDefinitions.cardUpdatedEvent)(requesterId, id, changes);
      return this.stateManager.addEvent(event);
    }
  }, {
    key: 'updateLabel',
    value: function updateLabel(cardId, label, labelWillBeSet) {
      var requesterId = this.stateManager.getUserId();
      var event = (0, _eventDefinitions.cardLabelUpdatedEvent)(requesterId, cardId, label, labelWillBeSet);
      return this.stateManager.addEvent(event);
    }
  }, {
    key: 'updateMember',
    value: function updateMember(cardId, userId, userWillBeAdded) {
      var requesterId = this.stateManager.getUserId();
      var event = (0, _eventDefinitions.cardMemberUpdatedEvent)(requesterId, cardId, userId, userWillBeAdded);
      return this.stateManager.addEvent(event);
    }
  }, {
    key: 'removeCard',
    value: function removeCard(cardId) {
      var requesterId = this.stateManager.getUserId();
      var event = (0, _eventDefinitions.cardRemovedEvent)(requesterId, cardId);
      return this.stateManager.addEvent(event);
    }
  }]);

  return CardsRepository;
}();

exports.default = CardsRepository;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = repositionAllCards;

function repositionAllCards(currentState, columnId) {
  currentState.bucket('cards').filter(function (c) {
    return c.columnId === columnId;
  }).reverse() // reverse to put first newer element if positions are equal
  .sort(function (c1, c2) {
    return c1.position - c2.position;
  }).forEach(function (c, i) {
    currentState.updateObject('cards', c.id, { position: i });
  });
}

/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("path");

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ColumnsRepository = function () {
  function ColumnsRepository(stateManager) {
    _classCallCheck(this, ColumnsRepository);

    this.stateManager = stateManager;
  }

  _createClass(ColumnsRepository, [{
    key: 'get',
    value: function get(columnId) {
      var columns = this.stateManager.bucket('columns');
      return columns.filter(function (column) {
        return column.id === columnId;
      })[0];
    }
  }, {
    key: 'columnsSortedByPosition',
    value: function columnsSortedByPosition() {
      var columns = this.stateManager.bucket('columns');
      return columns.sort(function (c1, c2) {
        return c1.position - c2.position;
      });
    }
  }, {
    key: 'addColumn',
    value: function addColumn(name) {
      var requesterId = this.stateManager.getUserId();
      var lastColumn = this.columnsSortedByPosition().reverse()[0] || { position: -1 };
      var lastPosition = lastColumn.position + 1;

      var event = (0, _eventDefinitions.columnAddedEvent)(requesterId, {
        name: name,
        position: lastPosition
      });
      return this.stateManager.addEvent(event);
    }
  }, {
    key: 'updateColumn',
    value: function updateColumn(id, changes) {
      var requesterId = this.stateManager.getUserId();
      var event = (0, _eventDefinitions.columnUpdatedEvent)(requesterId, id, changes);
      return this.stateManager.addEvent(event);
    }
  }, {
    key: 'removeColumn',
    value: function removeColumn(id) {
      var requesterId = this.stateManager.getUserId();
      var event = (0, _eventDefinitions.columnRemovedEvent)(requesterId, id);
      return this.stateManager.addEvent(event);
    }
  }]);

  return ColumnsRepository;
}();

exports.default = ColumnsRepository;

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CommentsRepository = function () {
  function CommentsRepository(stateManager, fileUploader) {
    _classCallCheck(this, CommentsRepository);

    this.stateManager = stateManager;
    this.fileUploader = fileUploader;
  }

  _createClass(CommentsRepository, [{
    key: 'get',
    value: function get(id) {
      var bucket = this.stateManager.bucket('comments');
      return bucket.filter(function (c) {
        return c.id === id;
      })[0];
    }
  }, {
    key: 'commentsCountForCard',
    value: function commentsCountForCard(cardId) {
      var bucket = this.stateManager.bucket('comments');
      return bucket.filter(function (c) {
        return c.cardId === cardId;
      }).length;
    }
  }, {
    key: 'commentsForCard',
    value: function commentsForCard(cardId) {
      var bucket = this.stateManager.bucket('comments');
      return bucket.filter(function (c) {
        return c.cardId === cardId;
      }).sort(function (c1, c2) {
        return c2.createdAt - c1.createdAt;
      });
    }
  }, {
    key: 'addComment',
    value: function addComment(cardId, params) {
      var requesterId = this.stateManager.getUserId();
      var attachment = params.attachment;

      if (attachment) {
        return this.addCommentWithAttachment(requesterId, cardId, params);
      }

      return this.addCommentWithoutAttachment(requesterId, cardId, params);
    }
  }, {
    key: 'removeComment',
    value: function removeComment(commentId) {
      var requesterId = this.stateManager.getUserId();
      var event = (0, _eventDefinitions.commentRemovedEvent)(requesterId, commentId);
      return this.stateManager.addEvent(event);
    }

    // private

  }, {
    key: 'addCommentWithAttachment',
    value: function addCommentWithAttachment(requesterId, cardId, params) {
      var _this = this;

      var content = params.content,
          attachment = params.attachment;


      return this.fileUploader.uploadFileFromFileBlob(attachment.blob).then(function (attachmentUrl) {
        var event = (0, _eventDefinitions.commentAddedEvent)(requesterId, cardId, {
          content: content,
          attachmentName: attachment.name,
          attachmentSize: attachment.size,
          attachmentType: attachment.type,
          attachmentUrl: attachmentUrl
        });
        return _this.stateManager.addEvent(event);
      });
    }
  }, {
    key: 'addCommentWithoutAttachment',
    value: function addCommentWithoutAttachment(requesterId, cardId, params) {
      var content = params.content;


      var event = (0, _eventDefinitions.commentAddedEvent)(requesterId, cardId, {
        content: content
      });
      return this.stateManager.addEvent(event);
    }
  }]);

  return CommentsRepository;
}();

exports.default = CommentsRepository;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _settingsUpdated = __webpack_require__(36);

var _settingsUpdated2 = _interopRequireDefault(_settingsUpdated);

var _columnAdded = __webpack_require__(31);

var _columnAdded2 = _interopRequireDefault(_columnAdded);

var _columnUpdated = __webpack_require__(33);

var _columnUpdated2 = _interopRequireDefault(_columnUpdated);

var _columnRemoved = __webpack_require__(32);

var _columnRemoved2 = _interopRequireDefault(_columnRemoved);

var _cardAdded = __webpack_require__(27);

var _cardAdded2 = _interopRequireDefault(_cardAdded);

var _cardUpdated = __webpack_require__(30);

var _cardUpdated2 = _interopRequireDefault(_cardUpdated);

var _cardRemoved = __webpack_require__(10);

var _cardRemoved2 = _interopRequireDefault(_cardRemoved);

var _cardLabelUpdated = __webpack_require__(28);

var _cardLabelUpdated2 = _interopRequireDefault(_cardLabelUpdated);

var _cardMemberUpdated = __webpack_require__(29);

var _cardMemberUpdated2 = _interopRequireDefault(_cardMemberUpdated);

var _commentAdded = __webpack_require__(34);

var _commentAdded2 = _interopRequireDefault(_commentAdded);

var _commentRemoved = __webpack_require__(35);

var _commentRemoved2 = _interopRequireDefault(_commentRemoved);

var _userUpdated = __webpack_require__(37);

var _userUpdated2 = _interopRequireDefault(_userUpdated);

var _allEvents = __webpack_require__(26);

var _allEvents2 = _interopRequireDefault(_allEvents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var State = function () {
  function State(params) {
    _classCallCheck(this, State);

    this.eventStorage = params.eventStorage;
    this.userId = params.userId;
    this.observers = [];
    this.data = {};
    this.eventHandlers = {};

    this.registerEventHandlers([new _allEvents2.default(), new _settingsUpdated2.default(), new _columnAdded2.default(), new _columnUpdated2.default(), new _columnRemoved2.default(), new _cardAdded2.default(), new _cardUpdated2.default(), new _cardRemoved2.default(), new _cardLabelUpdated2.default(), new _cardMemberUpdated2.default(), new _commentAdded2.default(), new _commentRemoved2.default(), new _userUpdated2.default()]);

    this.eventStorage.addObserver(this);
    this.processAllPastEvents();
  }

  _createClass(State, [{
    key: 'addObserver',
    value: function addObserver(observer) {
      this.observers.push(observer);
    }
  }, {
    key: 'removeObserver',
    value: function removeObserver(observer) {
      var objectIndex = this.observers.indexOf(observer);
      this.observers.splice(objectIndex, 1);
    }
  }, {
    key: 'purge',
    value: function purge() {
      this.data = {};
      this.onDataSynced();
      return Promise.resolve();
    }
  }, {
    key: 'addEvent',
    value: function addEvent(event) {
      return this.eventStorage.addEvent(event);
    }
  }, {
    key: 'getUserId',
    value: function getUserId() {
      return this.userId;
    }
  }, {
    key: 'bucket',
    value: function bucket(bucketName) {
      if (!this.data[bucketName]) {
        this.data[bucketName] = [];
      }
      return this.data[bucketName].slice(0);
    }

    // Event handlers helpers

  }, {
    key: 'addObject',
    value: function addObject(bucketName, object) {
      if (!this.data[bucketName]) {
        this.data[bucketName] = [];
      }
      this.data[bucketName].push(object);
    }
  }, {
    key: 'updateObject',
    value: function updateObject(bucketName, objectId, changes) {
      var objectIndex = this.bucket(bucketName).findIndex(function (object) {
        return object.id === objectId;
      });
      if (objectIndex < 0) return;

      var oldData = this.bucket(bucketName)[objectIndex];
      var updatedData = Object.assign(oldData, changes);
      this.data[bucketName][objectIndex] = updatedData;
    }
  }, {
    key: 'removeObject',
    value: function removeObject(bucketName, objectId) {
      var objectIndex = this.bucket(bucketName).findIndex(function (object) {
        return object.id === objectId;
      });
      if (objectIndex < 0) return;

      this.data[bucketName].splice(objectIndex, 1);
    }
  }, {
    key: 'objectData',
    value: function objectData(bucketName, objectId) {
      return this.bucket(bucketName).find(function (object) {
        return object.id === objectId;
      });
    }

    // private

  }, {
    key: 'onDataSynced',
    value: function onDataSynced() {
      this.observers.forEach(function (observer) {
        observer.onStateUpdate();
      });
    }
  }, {
    key: 'processAllPastEvents',
    value: function processAllPastEvents() {
      var _this = this;

      this.eventStorage.allPastEvents().then(function (events) {
        events.forEach(function (event) {
          _this.onNewEvent(event, false);
        });
        _this.onDataSynced();
      });
    }
  }, {
    key: 'registerEventHandlers',
    value: function registerEventHandlers(arrayOfeventHandlerClasses) {
      var _this2 = this;

      arrayOfeventHandlerClasses.forEach(function (eh) {
        _this2.eventHandlers[eh.forEvent()] = eh;
      });
    }

    //
    // eventStorage callback

  }, {
    key: 'onNewEvent',
    value: function onNewEvent(event) {
      var notifyObservers = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      var handlerName = event.type;
      var eventHandler = this.eventHandlers[handlerName];
      var allEventsHandler = this.eventHandlers.allEventTypes;
      var handlerParmas = { stateManager: this, event: event };

      if (allEventsHandler) allEventsHandler.execute(handlerParmas);
      if (eventHandler) eventHandler.execute(handlerParmas);

      if (notifyObservers && (allEventsHandler || eventHandler)) {
        this.onDataSynced();
      }
    }
  }]);

  return State;
}();

exports.default = State;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var rng = __webpack_require__(22);
var bytesToUuid = __webpack_require__(21);

function v4(options, buf, offset) {
  var i = buf && offset || 0;

  if (typeof options == 'string') {
    buf = options == 'binary' ? new Array(16) : null;
    options = null;
  }
  options = options || {};

  var rnds = options.random || (options.rng || rng)();

  // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
  rnds[6] = rnds[6] & 0x0f | 0x40;
  rnds[8] = rnds[8] & 0x3f | 0x80;

  // Copy bytes to buffer, if provided
  if (buf) {
    for (var ii = 0; ii < 16; ++ii) {
      buf[i + ii] = rnds[ii];
    }
  }

  return buf || bytesToUuid(rnds);
}

module.exports = v4;

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _commentsRepository = __webpack_require__(7);

var _commentsRepository2 = _interopRequireDefault(_commentsRepository);

var _eventDefinitions = __webpack_require__(0);

var _repositionAllCards = __webpack_require__(4);

var _repositionAllCards2 = _interopRequireDefault(_repositionAllCards);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CardRemoved = function () {
  function CardRemoved() {
    _classCallCheck(this, CardRemoved);
  }

  _createClass(CardRemoved, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.cardRemovedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      this.stateManager = stateManager;

      var card = this.stateManager.objectData('cards', event.data.cardId);
      if (!card) return;

      this.removeComments(card);
      this.removeCard(card);
      this.repositionOtherCards(card);
    }

    // private

  }, {
    key: 'removeComments',
    value: function removeComments(card) {
      var _this = this;

      var commentsRepo = new _commentsRepository2.default(this.stateManager);
      commentsRepo.commentsForCard(card.id).forEach(function (comment) {
        _this.stateManager.removeObject('comments', comment.id);
      });
    }
  }, {
    key: 'removeCard',
    value: function removeCard(card) {
      this.stateManager.removeObject('cards', card.id);
    }
  }, {
    key: 'repositionOtherCards',
    value: function repositionOtherCards(card) {
      (0, _repositionAllCards2.default)(this.stateManager, card.columnId);
    }
  }]);

  return CardRemoved;
}();

exports.default = CardRemoved;

/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = repositionAllColumns;

function repositionAllColumns(currentState) {
  currentState.bucket('columns').sort(function (c1, c2) {
    return c1.position - c2.position;
  }).forEach(function (c, i) {
    currentState.updateObject('columns', c.id, { position: i });
  });
}

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /* eslint-disable no-multi-spaces */

var _path = __webpack_require__(5);

var _path2 = _interopRequireDefault(_path);

var _express = __webpack_require__(43);

var _express2 = _interopRequireDefault(_express);

var _socket = __webpack_require__(47);

var _socket2 = _interopRequireDefault(_socket);

var _multer = __webpack_require__(46);

var _multer2 = _interopRequireDefault(_multer);

var _bodyParser = __webpack_require__(40);

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _storeFileUsecase = __webpack_require__(39);

var _storeFileUsecase2 = _interopRequireDefault(_storeFileUsecase);

var _sendFileUsecase = __webpack_require__(38);

var _sendFileUsecase2 = _interopRequireDefault(_sendFileUsecase);

var _eventProcessorsQueue = __webpack_require__(25);

var _eventProcessorsQueue2 = _interopRequireDefault(_eventProcessorsQueue);

var _state = __webpack_require__(8);

var _state2 = _interopRequireDefault(_state);

var _allowEveryoneAuth = __webpack_require__(24);

var _allowEveryoneAuth2 = _interopRequireDefault(_allowEveryoneAuth);

var _nullLogger = __webpack_require__(2);

var _nullLogger2 = _interopRequireDefault(_nullLogger);

var _utils = __webpack_require__(1);

var _eventDefinitions = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Server = function () {
  function Server(params) {
    _classCallCheck(this, Server);

    this.eventStorage = params.eventStorage || (0, _utils.hasToBeSet)('eventStorage');
    this.filesStorage = params.filesStorage || (0, _utils.hasToBeSet)('filesStorage');
    this.serverPort = params.port || 9000;
    this.uploadsDir = params.uploadsDir || _path2.default.resolve('.tmp/tmpUploads/');
    this.logger = params.logger || new _nullLogger2.default();
    this.auth = params.auth || new _allowEveryoneAuth2.default();
    this.noBanner = params.noBanner || false;
    this.eventProcessors = params.eventProcessors || [];
    this.state = params.state || new _state2.default({ eventStorage: this.eventStorage });

    this.server = null;
    this.sockets = [];
    this.sendFileUsecase = new _sendFileUsecase2.default({ filesStorage: this.filesStorage });
    this.storeFileUsecase = new _storeFileUsecase2.default({
      filesStorage: this.filesStorage,
      eventStorage: this.eventStorage
    });
    this.incommingEventProcessors = new _eventProcessorsQueue2.default({
      stateManager: this.state,
      processors: this.eventProcessors
    });
  }

  _createClass(Server, [{
    key: 'displayBanner',
    value: function displayBanner() {
      // eslint-disable-next-line no-console
      console.log('\n    |\n    | Starting Starboard...\n    | ' + this.eventStorage.welcomeInfo() + '\n    | ' + this.auth.welcomeInfo() + '\n    |\n    | Board available at: http://localhost:' + this.serverPort + '/\n    |\n    ');
    }
  }, {
    key: 'start',
    value: function start() {
      var _this = this;

      if (!this.noBanner) {
        this.displayBanner();
      }

      var app = (0, _express2.default)();
      var server = app.listen(this.serverPort);
      var io = (0, _socket2.default)(server);
      var upload = (0, _multer2.default)({ dest: this.uploadsDir });

      this.server = server;

      app.use(_express2.default.static(_path2.default.resolve(__dirname + '/frontend/')));
      app.use(_bodyParser2.default.json());

      // ----------------- http -----------------
      app.get('/attachments/:fileName', function (req, res) {
        _this.sendFileUsecase.sendResponse({
          fileName: req.params.fileName,
          expressResponse: res
        });
      });

      app.post('/attachments/', upload.single('attachment'), function (req, res) {
        _this.storeFileUsecase.addFile(req.file).then(function (fileUrl) {
          res.send({ attachmentUrl: fileUrl });
        });
      });

      app.post('/login/', function (req, res) {
        var _req$body = req.body,
            email = _req$body.email,
            password = _req$body.password;

        _this.auth.authWithCredentials(email, password).then(function (authData) {
          res.send({ userId: authData.userId, token: authData.token });
        }).catch(function () {
          res.send(403, 'access denied');
        });
      });

      // ----------- websockets utils -----------
      var allClientsNotifier = {
        onNewEvent: function onNewEvent(newEvent) {
          _this.sockets.forEach(function (socket) {
            socket.emit('newEvent', newEvent);
          });
        }
      };
      this.eventStorage.addObserver(allClientsNotifier);

      // -------------- webSockets --------------
      io.on('connection', function (socket) {
        _this.auth.authWithToken(socket.handshake.query.token).then(function () {
          _this.configureSocket(socket);
          socket.emit('accessGranted');
        }).catch(function () {
          socket.emit('accessDenied');
          socket.disconnect();
        });
      });
    }
  }, {
    key: 'stop',
    value: function stop() {
      this.server.close();
      this.server = null;
    }

    // private

  }, {
    key: 'configureSocket',
    value: function configureSocket(socket) {
      var _this2 = this;

      this.sockets.push(socket);
      socket.on('disconnect', function () {
        _this2.sockets.splice(_this2.sockets.indexOf(socket), 1);
      });

      socket.on('addEvent', function (event, sendBack) {
        _this2.auth.allowEvent(event, socket.handshake.query.token).then(function () {
          return _this2.incommingEventProcessors.processEvent(event);
        }).then(function () {
          sendBack(event);
          _this2.eventStorage.addEvent(event);
        }).catch(function () {
          sendBack((0, _eventDefinitions.permissionDeniedEvent)(event));
        });
      });

      socket.on('getAllPastEvents', function (sendBack) {
        _this2.eventStorage.allPastEvents().then(function (events) {
          sendBack(events);
        });
      });
    }
  }]);

  return Server;
}();

exports.default = Server;

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DependencyInjector = function () {
  function DependencyInjector() {
    _classCallCheck(this, DependencyInjector);

    this.objects = {};
    this.executors = {};
  }

  _createClass(DependencyInjector, [{
    key: "set",
    value: function set(name, executor) {
      this.executors[name] = executor;
      return this;
    }
  }, {
    key: "get",
    value: function get(name) {
      if (!this.objects[name]) {
        var executor = this.executors[name];
        if (!executor) throw new Error("Dependency \"" + name + "\" was never set.");
        this.objects[name] = this.executors[name](this);
      }

      return this.objects[name];
    }
  }]);

  return DependencyInjector;
}();

exports.default = DependencyInjector;

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

var _nullLogger = __webpack_require__(2);

var _nullLogger2 = _interopRequireDefault(_nullLogger);

var _utils = __webpack_require__(1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GitEventStorage = function () {
  function GitEventStorage(params) {
    _classCallCheck(this, GitEventStorage);

    this.syncingInterval = params.syncingInterval || 30;
    this.git = params.gitContainer || (0, _utils.hasToBeSet)('gitContainer');
    this.logger = params.logger || new _nullLogger2.default();

    this.observers = [];
    this.lastSyncedCommit = undefined;
    this.eventIdsSinceLastSync = [];
    this.queue = Promise.resolve();

    this.start();
  }

  _createClass(GitEventStorage, [{
    key: 'welcomeInfo',
    value: function welcomeInfo() {
      return 'Source GIT repo set to: ' + this.git.remoteRepoUrl;
    }
  }, {
    key: 'addObserver',
    value: function addObserver(observer) {
      this.observers.push(observer);
    }
  }, {
    key: 'addEvent',
    value: function addEvent(event) {
      var _this = this;

      return new Promise(function (resolve, _reject) {
        _this.queue = _this.queue.then(function () {
          return _this.applyEvent(event);
        }).then(resolve);
      });
    }
  }, {
    key: 'removeFile',
    value: function removeFile(fileNameInGitFolder) {
      var _this2 = this;

      return new Promise(function (resolve, _reject) {
        var event = (0, _eventDefinitions.fileRemovedEvent)(_this2.commiterEmail, fileNameInGitFolder);
        _this2.queue = _this2.queue.then(function () {
          return _this2.git.removeFile(fileNameInGitFolder);
        }).then(function () {
          return _this2.applyEvent(event);
        }).then(function () {
          resolve(fileNameInGitFolder);
        });
      });
    }
  }, {
    key: 'allPastEvents',
    value: function allPastEvents() {
      var _this3 = this;

      return new Promise(function (resolve, _reject) {
        _this3.queue = _this3.queue.then(function () {
          return _this3.git.getAllCommitMessages();
        }).then(function (commitMessagesText) {
          return _this3.extractEventsFromCommits(commitMessagesText);
        }).then(resolve);
      });
    }
  }, {
    key: 'sync',
    value: function sync() {
      var _this4 = this;

      return new Promise(function (resolve, _reject) {
        _this4.queue = _this4.queue.then(function () {
          return _this4.git.pushChangesWithEventualRebase();
        }) // Push With Eventual Rebase will
        // fetch data also whenever clear push
        // is rejected.
        // After rebase some old events
        // will reappear again, however those events
        // wont be applied again because of
        // eventIdsSinceLastSync guarding mechanism
        // It handles both scenarios where there
        // is something new on remote or on local.
        .then(function () {
          return _this4.gatherUnsyncedEvents();
        }).then(function () {
          return _this4.updateLastSyncedCommit();
        }).then(resolve);
      });
    }

    // private

  }, {
    key: 'start',
    value: function start() {
      var _this5 = this;

      this.queue = this.queue.then(function () {
        return _this5.setupLocalRepo();
      });

      this.syncingLoopTimer = this.startPollingLoop(this.syncingInterval);
    }
  }, {
    key: 'setupLocalRepo',
    value: function setupLocalRepo() {
      var _this6 = this;

      return this.git.initRepo().then(function () {
        return _this6.git.addUser();
      }).then(function () {
        return _this6.git.addRemote();
      }).then(function () {
        return _this6.setupLocalAndRemoteBranch();
      });
    }
  }, {
    key: 'setupLocalAndRemoteBranch',
    value: function setupLocalAndRemoteBranch() {
      var _this7 = this;

      return this.git.createDataBranch().then(function () {
        return _this7.git.pullChanges();
      }).catch(function () {
        return _this7.pushEmptySetupCommit();
      });
    }
  }, {
    key: 'notify',
    value: function notify(event) {
      this.observers.forEach(function (observer) {
        observer.onNewEvent(event);
      });
    }
  }, {
    key: 'applyEvent',
    value: function applyEvent(event) {
      var _this8 = this;

      return this.git.commit(JSON.stringify(event)).then(function () {
        _this8.eventIdsSinceLastSync.push(event.id);
      }).then(function () {
        return _this8.notify(event);
      });
    }
  }, {
    key: 'gatherUnsyncedEvents',
    value: function gatherUnsyncedEvents() {
      var _this9 = this;

      return this.git.calculateDiffCommitMessages(this.lastSyncedCommit).then(function (commitMessagesText) {
        return _this9.extractEventsFromCommits(commitMessagesText);
      }).then(function (events) {
        events.filter(function (event) {
          return _this9.eventIdsSinceLastSync.indexOf(event.id) === -1;
        }).forEach(function (event) {
          _this9.notify(event);
        });
      });
    }
  }, {
    key: 'extractEventsFromCommits',
    value: function extractEventsFromCommits(textWithCommits) {
      var messages = textWithCommits.split('\n') // separate commits
      .filter(function (e) {
        return e;
      }) // remove empty strings
      .reverse(); // change order to earliest first

      var events = messages.map(function (message) {
        var extractedJson = message.split(' ').slice(1).join(' '); // remove commit hash from message
        var event = JSON.parse(extractedJson);
        return event;
      });
      return events;
    }
  }, {
    key: 'updateLastSyncedCommit',
    value: function updateLastSyncedCommit() {
      var _this10 = this;

      this.eventIdsSinceLastSync = [];
      return this.git.commitHash().then(function (hash) {
        _this10.lastSyncedCommit = hash;
      });
    }
  }, {
    key: 'startPollingLoop',
    value: function startPollingLoop(syncingInterval) {
      var _this11 = this;

      if (syncingInterval <= 0) return null;
      this.sync();
      return setInterval(function () {
        _this11.sync();
      }, syncingInterval * 1000);
    }
  }, {
    key: 'pushEmptySetupCommit',
    value: function pushEmptySetupCommit() {
      var _this12 = this;

      var event = (0, _eventDefinitions.noopEvent)();
      return this.git.commit(JSON.stringify(event)).then(function () {
        return _this12.git.pushChangesWithEventualRebase();
      });
    }
  }]);

  return GitEventStorage;
}();

exports.default = GitEventStorage;

/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nullLogger = __webpack_require__(2);

var _nullLogger2 = _interopRequireDefault(_nullLogger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MemoryEventStorage = function () {
  function MemoryEventStorage() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, MemoryEventStorage);

    this.logger = params.logger || new _nullLogger2.default();
    this.events = [];
    this.observers = [];
  }

  _createClass(MemoryEventStorage, [{
    key: 'welcomeInfo',
    value: function welcomeInfo() {
      return 'Using Memory Storage';
    }
  }, {
    key: 'addObserver',
    value: function addObserver(observer) {
      this.observers.push(observer);
    }
  }, {
    key: 'addEvent',
    value: function addEvent(event) {
      var _this = this;

      return new Promise(function (resolve, _reject) {
        _this.events.push(event);
        _this.notify(event);
        _this.logger.log(event);
        resolve();
      });
    }
  }, {
    key: 'allPastEvents',
    value: function allPastEvents() {
      return Promise.resolve(this.events);
    }

    // private

  }, {
    key: 'notify',
    value: function notify(event) {
      this.observers.forEach(function (observer) {
        observer.onNewEvent(event);
      });
    }
  }]);

  return MemoryEventStorage;
}();

exports.default = MemoryEventStorage;

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _socket = __webpack_require__(48);

var _socket2 = _interopRequireDefault(_socket);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ServerEventStorage = function () {
  function ServerEventStorage() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, ServerEventStorage);

    var uri = params.uri || undefined; // same domain
    this.token = params.token;
    this.queue = Promise.resolve();
    this.observers = [];
    this.addedEventIDs = []; // To have smooth adding flow,
    // we notify on success add,
    // and ignore that event comming back
    // from server (via newEvent channel)
    this.socket = (0, _socket2.default)(uri, { query: 'token=' + this.token });

    this.start();
  }

  _createClass(ServerEventStorage, [{
    key: 'welcomeInfo',
    value: function welcomeInfo() {
      return 'Using SocketIO proxy Storage (' + this.socket.io.uri + ')';
    }
  }, {
    key: 'addObserver',
    value: function addObserver(observer) {
      this.observers.push(observer);
    }
  }, {
    key: 'addEvent',
    value: function addEvent(event) {
      var _this = this;

      return new Promise(function (resolve, _reject) {
        _this.addedEventIDs.push(event.id);
        _this.socket.emit('addEvent', event, function () {
          _this.notify(event);
          resolve();
        });
      });
    }
  }, {
    key: 'allPastEvents',
    value: function allPastEvents() {
      var _this2 = this;

      return new Promise(function (resolve, _reject) {
        _this2.queue = _this2.queue.then(function () {
          _this2.socket.emit('getAllPastEvents', resolve);
        });
      });
    }

    // private

  }, {
    key: 'start',
    value: function start() {
      var _this3 = this;

      this.queue = this.queue.then(function () {
        return new Promise(function (resolve, _reject) {
          _this3.socket.on('accessGranted', function () {
            _this3.startListeningForEvents();
            resolve();
          });
        });
      });
    }
  }, {
    key: 'startListeningForEvents',
    value: function startListeningForEvents() {
      var _this4 = this;

      this.socket.on('newEvent', function (event) {
        _this4.onNewEventFromServer(event);
      });
    }
  }, {
    key: 'onNewEventFromServer',
    value: function onNewEventFromServer(event) {
      if (this.addedEventIDs.indexOf(event.id) === -1) {
        this.notify(event);
      }
    }
  }, {
    key: 'notify',
    value: function notify(event) {
      this.observers.forEach(function (observer) {
        observer.onNewEvent(event);
      });
    }
  }]);

  return ServerEventStorage;
}();

exports.default = ServerEventStorage;

/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = __webpack_require__(5);

var _path2 = _interopRequireDefault(_path);

var _mkdirp = __webpack_require__(45);

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _child_process = __webpack_require__(41);

var _utils = __webpack_require__(1);

var _nullLogger = __webpack_require__(2);

var _nullLogger2 = _interopRequireDefault(_nullLogger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var swallowErrors = function swallowErrors() {};

var GitContainer = function () {
  function GitContainer(params) {
    _classCallCheck(this, GitContainer);

    this.pathToTempLocalRepo = _path2.default.resolve(params.pathToTempLocalRepo) || _path2.default.resolve('.tmp/tmpRepo/');
    this.commiterUsername = params.commiterUsername || 'Starboard BOT';
    this.commiterEmail = params.commiterEmail || 'starboardbot@localhost';
    this.dataBranchName = params.dataBranchName || '__starboard-data';
    this.remoteRepoUrl = params.remoteRepoUrl || (0, _utils.hasToBeSet)('remoteRepoUrl');
    this.pathToSshPrivateKey = params.pathToSshPrivateKey && _path2.default.resolve(params.pathToSshPrivateKey);
    this.logger = params.logger || new _nullLogger2.default();

    _mkdirp2.default.sync(this.pathToTempLocalRepo);
    this.configurePrivateKeyIfNeeded();
  }

  _createClass(GitContainer, [{
    key: 'initRepo',
    value: function initRepo() {
      return this.execute('git init ' + this.pathToTempLocalRepo);
    }
  }, {
    key: 'addUser',
    value: function addUser() {
      var _this = this;

      return Promise.resolve().then(function () {
        return _this.execute('git -C ' + _this.pathToTempLocalRepo + ' config user.name "' + _this.commiterUsername + '"');
      }).then(function () {
        return _this.execute('git -C ' + _this.pathToTempLocalRepo + ' config user.email "' + _this.commiterEmail + '"');
      });
    }
  }, {
    key: 'createDataBranch',
    value: function createDataBranch() {
      return this.execute('git -C ' + this.pathToTempLocalRepo + ' checkout -b ' + this.dataBranchName).catch(swallowErrors);
    }
  }, {
    key: 'addRemote',
    value: function addRemote() {
      return this.execute('git -C ' + this.pathToTempLocalRepo + ' remote add origin ' + this.remoteRepoUrl).catch(swallowErrors);
    }
  }, {
    key: 'commitHash',
    value: function commitHash() {
      return this.execute('git -C ' + this.pathToTempLocalRepo + ' rev-parse ' + this.dataBranchName);
    }
  }, {
    key: 'calculateDiffCommitMessages',
    value: function calculateDiffCommitMessages(lastSyncedCommit) {
      if (lastSyncedCommit) {
        return this.execute('git -C ' + this.pathToTempLocalRepo + ' log --oneline                            ' + lastSyncedCommit + '...' + this.dataBranchName);
      }
      return this.getAllCommitMessages();
    }
  }, {
    key: 'getAllCommitMessages',
    value: function getAllCommitMessages() {
      return this.execute('git -C ' + this.pathToTempLocalRepo + ' log --oneline ' + this.dataBranchName);
    }
  }, {
    key: 'pullChanges',
    value: function pullChanges() {
      return this.execute('git -C ' + this.pathToTempLocalRepo + ' pull --rebase origin ' + this.dataBranchName);
    }
  }, {
    key: 'pushChanges',
    value: function pushChanges() {
      return this.execute('git -C ' + this.pathToTempLocalRepo + ' push origin ' + this.dataBranchName);
    }
  }, {
    key: 'addFile',
    value: function addFile(fileNameInGitFolder, commitMessage) {
      return this.execute('\n      git -C ' + this.pathToTempLocalRepo + ' add "' + fileNameInGitFolder + '" ;\n      ' + this.commitShellCommand(commitMessage) + '\n    ');
    }
  }, {
    key: 'removeFile',
    value: function removeFile(filePath) {
      return this.execute('git -C ' + this.pathToTempLocalRepo + ' rm "' + filePath + '"');
    }
  }, {
    key: 'pushChangesWithEventualRebase',
    value: function pushChangesWithEventualRebase() {
      var _this2 = this;

      //
      // try to push till it success,
      // on fail: pull changes and try again
      return this.pushChanges().catch(function () {
        return _this2.pullChanges().then(_this2.gitPushChangesWithEventualRebase.bind(_this2));
      });
    }
  }, {
    key: 'commit',
    value: function commit(message) {
      return this.execute(this.commitShellCommand(message));
    }

    // private

  }, {
    key: 'commitShellCommand',
    value: function commitShellCommand(message) {
      var escapedMessage = message.replace(/'/g, '\'"\'"\''); // replace ' -> '"'"'
      return 'git -C ' + this.pathToTempLocalRepo + ' commit --allow-empty -m \'' + escapedMessage + '\'';
    }
  }, {
    key: 'configurePrivateKeyIfNeeded',
    value: function configurePrivateKeyIfNeeded() {
      if (!this.pathToSshPrivateKey) return;
      //
      // taken from:
      // https://superuser.com/a/912281
      process.env.GIT_SSH_COMMAND = 'ssh -i ' + this.pathToSshPrivateKey + ' -F /dev/null';
    }
  }, {
    key: 'execute',
    value: function execute(command) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        (0, _child_process.exec)(command, { env: process.env }, function (error, stdout, _stderr) {
          _this3.logger.log(command);
          if (error) {
            return reject(error);
          }
          return resolve(stdout.trim());
        });
      });
    }
  }]);

  return GitContainer;
}();

exports.default = GitContainer;

/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = __webpack_require__(5);

var _path2 = _interopRequireDefault(_path);

var _v = __webpack_require__(9);

var _v2 = _interopRequireDefault(_v);

var _fs = __webpack_require__(44);

var _fs2 = _interopRequireDefault(_fs);

var _utils = __webpack_require__(1);

var _eventDefinitions = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GitFilesStorage = function () {
  function GitFilesStorage(params) {
    _classCallCheck(this, GitFilesStorage);

    this.git = params.gitContainer || (0, _utils.hasToBeSet)('gitContainer');
  }

  _createClass(GitFilesStorage, [{
    key: 'fileUrl',
    value: function fileUrl(filePath) {
      return _path2.default.resolve(this.git.pathToTempLocalRepo, filePath);
    }
  }, {
    key: 'rootPath',
    value: function rootPath() {
      return this.git.pathToTempLocalRepo;
    }
  }, {
    key: 'addFile',
    value: function addFile(params) {
      var _this = this;

      var fileName = params.fileName,
          filePath = params.filePath;


      var uniqueFileName = (0, _v2.default)() + '---' + fileName;
      var uniqueFilePath = this.fileUrl(uniqueFileName);

      return new Promise(function (resolve, reject) {
        _fs2.default.rename(filePath, uniqueFilePath, function (err) {
          return err ? reject(err) : resolve();
        });
      }).then(function () {
        return _this.git.addFile(uniqueFileName, _this.fileAddingCommitMassage(uniqueFileName));
      }).then(function () {
        return uniqueFileName;
      });
    }

    // private

  }, {
    key: 'fileAddingCommitMassage',
    value: function fileAddingCommitMassage(filePath) {
      return JSON.stringify((0, _eventDefinitions.noopEvent)('storing a file: ' + filePath));
    }
  }]);

  return GitFilesStorage;
}();

exports.default = GitFilesStorage;

/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SettingsRepository = function () {
  function SettingsRepository(stateManager) {
    _classCallCheck(this, SettingsRepository);

    this.stateManager = stateManager;
  }

  _createClass(SettingsRepository, [{
    key: 'availableColorSpecs',
    value: function availableColorSpecs() {
      return {
        '#00E6FF': { name: 'cyan', isDark: false },
        '#3CB500': { name: 'green', isDark: true },
        '#FAD900': { name: 'yellow', isDark: false },
        '#FF9F19': { name: 'orange', isDark: false },
        '#EB4646': { name: 'red', isDark: true },
        '#A632DB': { name: 'purple', isDark: true },
        '#0079BF': { name: 'blue', isDark: true }
      };
    }
  }, {
    key: 'availableColors',
    value: function availableColors() {
      return Object.keys(this.availableColorSpecs());
    }
  }, {
    key: 'isThemeColorDark',
    value: function isThemeColorDark() {
      var color = this.themeColor();
      return this.availableColorSpecs()[color].isDark;
    }
  }, {
    key: 'themeColor',
    value: function themeColor() {
      return this.get('themeColor', '#3CB500');
    }
  }, {
    key: 'setThemeColor',
    value: function setThemeColor(hexColor) {
      return this.set('themeColor', hexColor);
    }
  }, {
    key: 'boardName',
    value: function boardName() {
      return this.get('boardName', '');
    }
  }, {
    key: 'setBoardName',
    value: function setBoardName(name) {
      return this.set('boardName', name);
    }
  }, {
    key: 'textForLabel',
    value: function textForLabel(color) {
      var withNamedDefault = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var key = 'label-' + color;
      var defaultText = '';
      if (withNamedDefault) {
        defaultText = this.availableColorSpecs()[color].name;
      }
      return this.get(key, defaultText);
    }
  }, {
    key: 'setTextForLabel',
    value: function setTextForLabel(color, value) {
      var key = 'label-' + color;
      return this.set(key, value);
    }

    // private

  }, {
    key: 'get',
    value: function get(key, defautValue) {
      var settings = this.stateManager.objectData('settings', key);
      var nullSettings = { value: defautValue };
      return (settings || nullSettings).value;
    }
  }, {
    key: 'set',
    value: function set(key, value) {
      var requesterId = this.stateManager.getUserId();
      var event = (0, _eventDefinitions.settingsUpdatedEvent)(requesterId, key, value);
      return this.stateManager.addEvent(event);
    }
  }]);

  return SettingsRepository;
}();

exports.default = SettingsRepository;

/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var UsersRepository = function () {
  function UsersRepository(stateManager, fileUploader) {
    _classCallCheck(this, UsersRepository);

    this.stateManager = stateManager;
    this.fileUploader = fileUploader;
  }

  _createClass(UsersRepository, [{
    key: 'all',
    value: function all() {
      return this.stateManager.bucket('users');
    }
  }, {
    key: 'currentUserId',
    value: function currentUserId() {
      return this.stateManager.getUserId();
    }
  }, {
    key: 'currentUserNickname',
    value: function currentUserNickname() {
      var userId = this.currentUserId();
      return this.userNickname(userId);
    }
  }, {
    key: 'currentUserAvatarUrl',
    value: function currentUserAvatarUrl() {
      var userId = this.currentUserId();
      return this.userAvatarUrl(userId);
    }
  }, {
    key: 'userAvatarUrl',
    value: function userAvatarUrl(userId) {
      var user = this.stateManager.objectData('users', userId);
      return user && user.avatarUrl;
    }
  }, {
    key: 'userNickname',
    value: function userNickname(userId) {
      var user = this.stateManager.objectData('users', userId);
      return user && user.nickname;
    }
  }, {
    key: 'setCurrentUserNickname',
    value: function setCurrentUserNickname(nickname) {
      var userId = this.currentUserId();
      var requesterId = this.currentUserId();
      var event = (0, _eventDefinitions.userUpdatedEvent)(requesterId, userId, 'nickname', nickname);
      return this.stateManager.addEvent(event);
    }
  }, {
    key: 'setUserNickname',
    value: function setUserNickname(userId, nickname) {
      var requesterId = this.currentUserId();
      var event = (0, _eventDefinitions.userUpdatedEvent)(requesterId, userId, 'nickname', nickname);
      return this.stateManager.addEvent(event);
    }
  }, {
    key: 'setCurrentUserAvatar',
    value: function setCurrentUserAvatar(avatar) {
      var userId = this.currentUserId();
      return this.setUserAvatar(userId, avatar);
    }
  }, {
    key: 'setUserAvatar',
    value: function setUserAvatar(userId, avatar) {
      var _this = this;

      var requesterId = this.currentUserId();

      if (!avatar) {
        var event = (0, _eventDefinitions.userUpdatedEvent)(requesterId, userId, 'avatarUrl', null);
        return this.stateManager.addEvent(event);
      }

      return this.fileUploader.uploadFileFromFileBlob(avatar.blob).then(function (avatarUrl) {
        var event = (0, _eventDefinitions.userUpdatedEvent)(requesterId, userId, 'avatarUrl', avatarUrl);
        return _this.stateManager.addEvent(event);
      });
    }
  }]);

  return UsersRepository;
}();

exports.default = UsersRepository;

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */
var byteToHex = [];
for (var i = 0; i < 256; ++i) {
  byteToHex[i] = (i + 0x100).toString(16).substr(1);
}

function bytesToUuid(buf, offset) {
  var i = offset || 0;
  var bth = byteToHex;
  return bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + '-' + bth[buf[i++]] + bth[buf[i++]] + '-' + bth[buf[i++]] + bth[buf[i++]] + '-' + bth[buf[i++]] + bth[buf[i++]] + '-' + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]] + bth[buf[i++]];
}

module.exports = bytesToUuid;

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


// Unique ID creation requires a high quality random # generator.  In node.js
// this is pretty straight-forward - we use the crypto API.

var rb = __webpack_require__(42).randomBytes;

function rng() {
  return rb(16);
}

module.exports = rng;

/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* eslint-disable no-multi-spaces */
exports.Starboard = __webpack_require__(12).default;
exports.eventDefinitions = __webpack_require__(0);
exports.State = __webpack_require__(8).default;
exports.GitContainer = __webpack_require__(17).default;
exports.GitFilesStorage = __webpack_require__(18).default;
exports.GitEventStorage = __webpack_require__(14).default;
exports.MemoryEventStorage = __webpack_require__(15).default;
exports.ServerEventStorage = __webpack_require__(16).default;
exports.SettingsRepository = __webpack_require__(19).default;
exports.CardsRepository = __webpack_require__(3).default;
exports.ColumnsRepository = __webpack_require__(6).default;
exports.CommentsRepository = __webpack_require__(7).default;
exports.UsersRepository = __webpack_require__(20).default;
exports.DependecyIjector = __webpack_require__(13).default;

/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AllowEveryoneAuth = function () {
  function AllowEveryoneAuth() {
    _classCallCheck(this, AllowEveryoneAuth);
  }

  _createClass(AllowEveryoneAuth, [{
    key: 'welcomeInfo',
    value: function welcomeInfo() {
      return 'Auth: allow everyone';
    }
  }, {
    key: 'authWithCredentials',
    value: function authWithCredentials(email, _password) {
      return Promise.resolve({
        userId: email,
        token: 'AllowEveryoneToken'
      });
    }
  }, {
    key: 'authWithToken',
    value: function authWithToken(_token) {
      return Promise.resolve();
    }
  }, {
    key: 'allowEvent',
    value: function allowEvent(_event, _token) {
      return Promise.resolve();
    }
  }]);

  return AllowEveryoneAuth;
}();

exports.default = AllowEveryoneAuth;

/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EventProcessorsQueue = function () {
  function EventProcessorsQueue() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, EventProcessorsQueue);

    this.processors = params.processors || [];
  }

  _createClass(EventProcessorsQueue, [{
    key: "push",
    value: function push(processor) {
      this.processors.push(processor);
    }
  }, {
    key: "processEvent",
    value: function processEvent(event) {
      var _this = this;

      var queue = Promise.resolve();
      this.processors.forEach(function (processor) {
        if (_this.processorHandlesEvent(processor, event)) {
          queue = queue.then(function () {
            return processor.processEvent(event);
          });
        }
      });
      return queue;
    }

    // private

  }, {
    key: "processorHandlesEvent",
    value: function processorHandlesEvent(processor, event) {
      return processor.handleEvents().indexOf(event.type) !== -1;
    }
  }]);

  return EventProcessorsQueue;
}();

exports.default = EventProcessorsQueue;

/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _cardsRepository = __webpack_require__(3);

var _cardsRepository2 = _interopRequireDefault(_cardsRepository);

var _columnsRepository = __webpack_require__(6);

var _columnsRepository2 = _interopRequireDefault(_columnsRepository);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AllEvents = function () {
  function AllEvents() {
    _classCallCheck(this, AllEvents);
  }

  _createClass(AllEvents, [{
    key: 'forEvent',
    value: function forEvent() {
      return 'allEventTypes';
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      this.stateManager = stateManager;
      this.cardsRepo = new _cardsRepository2.default(this.stateManager);
      this.columnsRepo = new _columnsRepository2.default(this.stateManager);
      this.logActivity(event);
    }

    // private

  }, {
    key: 'logActivity',
    value: function logActivity(event) {
      var type = event.type.replace(/_/g, '');
      var handler = this[type + 'ActivityHandler'];
      return handler && handler.bind(this)(event);
    }

    // log event handlers

  }, {
    key: 'CARDADDEDActivityHandler',
    value: function CARDADDEDActivityHandler(event) {
      var title = event.data.title;

      var activity = event;
      activity.meta = { cardTitle: title };
      this.storeActivity(activity);
    }
  }, {
    key: 'CARDREMOVEDActivityHandler',
    value: function CARDREMOVEDActivityHandler(event) {
      var cardId = event.data.cardId;

      var card = this.cardsRepo.get(cardId);
      if (!card) return;

      var activity = event;
      activity.meta = { cardTitle: card.title };
      this.storeActivity(activity);
    }
  }, {
    key: 'CARDLABELUPDATEDActivityHandler',
    value: function CARDLABELUPDATEDActivityHandler(event) {
      var cardId = event.data.cardId;

      var card = this.cardsRepo.get(cardId);
      if (!card) return;

      var activity = event;
      activity.meta = { cardTitle: card.title };
      this.storeActivity(activity);
    }
  }, {
    key: 'CARDMEMBERUPDATEDActivityHandler',
    value: function CARDMEMBERUPDATEDActivityHandler(event) {
      var cardId = event.data.cardId;

      var card = this.cardsRepo.get(cardId);
      if (!card) return;

      var activity = event;
      activity.meta = { cardTitle: card.title };
      this.storeActivity(activity);
    }
  }, {
    key: 'COMMENTADDEDActivityHandler',
    value: function COMMENTADDEDActivityHandler(event) {
      var cardId = event.data.cardId;

      var card = this.cardsRepo.get(cardId);
      if (!card) return;

      var activity = event;
      activity.meta = { cardTitle: card.title };
      this.storeActivity(activity);
    }
  }, {
    key: 'COLUMNADDEDActivityHandler',
    value: function COLUMNADDEDActivityHandler(event) {
      var name = event.data.name;

      var activity = event;
      activity.meta = { columnName: name };
      this.storeActivity(activity);
    }
  }, {
    key: 'COLUMNREMOVEDActivityHandler',
    value: function COLUMNREMOVEDActivityHandler(event) {
      var columnId = event.data.columnId;

      var column = this.columnsRepo.get(columnId);
      if (!column) return;

      var activity = event;
      activity.meta = { columnName: column.name };
      this.storeActivity(activity);
    }

    // utils

  }, {
    key: 'storeActivity',
    value: function storeActivity(activity) {
      this.stateManager.addObject('activities', activity);
    }
  }]);

  return AllEvents;
}();

exports.default = AllEvents;

/***/ }),
/* 27 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

var _repositionAllCards = __webpack_require__(4);

var _repositionAllCards2 = _interopRequireDefault(_repositionAllCards);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CardAdded = function () {
  function CardAdded() {
    _classCallCheck(this, CardAdded);
  }

  _createClass(CardAdded, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.cardAddedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      var card = event.data;
      var column = stateManager.objectData('columns', card.columnId);
      if (!column) return;

      stateManager.addObject('cards', card);
      (0, _repositionAllCards2.default)(stateManager, card.columnId);
    }
  }]);

  return CardAdded;
}();

exports.default = CardAdded;

/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CardLabelUpdated = function () {
  function CardLabelUpdated() {
    _classCallCheck(this, CardLabelUpdated);
  }

  _createClass(CardLabelUpdated, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.cardLabelUpdatedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;
      var _event$data = event.data,
          cardId = _event$data.cardId,
          label = _event$data.label,
          shouldBeSet = _event$data.set;

      var card = stateManager.objectData('cards', cardId);
      if (!card) return;

      var labels = card.labels || [];

      if (shouldBeSet) {
        labels.push(label);
      } else {
        var existedLabelIndex = labels.indexOf(label);
        if (existedLabelIndex !== -1) {
          labels.splice(existedLabelIndex, 1);
        }
      }
      stateManager.updateObject('cards', cardId, { labels: labels });
    }
  }]);

  return CardLabelUpdated;
}();

exports.default = CardLabelUpdated;

/***/ }),
/* 29 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CardMemberUpdated = function () {
  function CardMemberUpdated() {
    _classCallCheck(this, CardMemberUpdated);
  }

  _createClass(CardMemberUpdated, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.cardMemberUpdatedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;
      var _event$data = event.data,
          cardId = _event$data.cardId,
          userId = _event$data.userId,
          shouldBeSet = _event$data.set;

      var card = stateManager.objectData('cards', cardId);
      if (!card) return;

      var userIds = card.memberIds || [];

      if (shouldBeSet) {
        userIds.push(userId);
      } else {
        var existedUserIdIndex = userIds.indexOf(userId);
        if (existedUserIdIndex !== -1) {
          userIds.splice(existedUserIdIndex, 1);
        }
      }

      stateManager.updateObject('cards', cardId, { memberIds: userIds });
    }
  }]);

  return CardMemberUpdated;
}();

exports.default = CardMemberUpdated;

/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

var _repositionAllCards = __webpack_require__(4);

var _repositionAllCards2 = _interopRequireDefault(_repositionAllCards);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CardUpdated = function () {
  function CardUpdated() {
    _classCallCheck(this, CardUpdated);
  }

  _createClass(CardUpdated, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.cardUpdatedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      this.stateManager = stateManager;

      var _event$data = event.data,
          cardId = _event$data.cardId,
          changes = _event$data.changes;

      var newPosition = changes.position;
      var newColumnId = changes.columnId;

      var cardOldData = this.stateManager.objectData('cards', cardId);
      if (!cardOldData) return;

      if (newPosition !== undefined || newColumnId !== undefined) {
        newPosition = newPosition !== undefined ? newPosition : cardOldData.position;
        newColumnId = newColumnId !== undefined ? newColumnId : cardOldData.columnId;

        this.updatePositionOfOtherCards(cardId, {
          oldPosition: cardOldData.position,
          newPosition: newPosition,
          oldColumnId: cardOldData.columnId,
          newColumnId: newColumnId
        });
      }

      this.stateManager.updateObject('cards', cardId, changes);
    }

    // private

  }, {
    key: 'updatePositionOfOtherCards',
    value: function updatePositionOfOtherCards(movedCardId, params) {
      var _this = this;

      var oldPosition = params.oldPosition,
          newPosition = params.newPosition,
          oldColumnId = params.oldColumnId,
          newColumnId = params.newColumnId;


      var cards = this.stateManager.bucket('cards').filter(function (c) {
        return c.columnId === newColumnId && c.id !== movedCardId;
      });

      if (newColumnId === oldColumnId) {
        //
        // Move a card within same column
        if (newPosition < oldPosition) {
          // Moving a card up
          // All cards after movedCardId's newPosition: update position +1
          cards.forEach(function (c) {
            if (c.position >= newPosition && c.position < oldPosition) {
              _this.stateManager.updateObject('cards', c.id, { position: c.position + 1 });
            }
          });
        } else {
          // Moving a card down
          // All cards before movedCardId's newPosition: update position -1
          cards.forEach(function (c) {
            if (c.position <= newPosition && c.position > oldPosition) {
              _this.stateManager.updateObject('cards', c.id, { position: c.position - 1 });
            }
          });
        }
      } else {
        //
        // Move a card to a different column
        // All cards in a new column, after movedCardId's newPosition: update position +1
        cards.forEach(function (c) {
          if (c.position >= newPosition) {
            _this.stateManager.updateObject('cards', c.id, { position: c.position + 1 });
          }
        });

        // All cards in an old column, update like the moved card was removed
        (0, _repositionAllCards2.default)(this.stateManager, oldColumnId);
      }
    }
  }]);

  return CardUpdated;
}();

exports.default = CardUpdated;

/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

var _repositionAllColumns = __webpack_require__(11);

var _repositionAllColumns2 = _interopRequireDefault(_repositionAllColumns);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ColumnAdded = function () {
  function ColumnAdded() {
    _classCallCheck(this, ColumnAdded);
  }

  _createClass(ColumnAdded, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.columnAddedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      stateManager.addObject('columns', event.data);
      (0, _repositionAllColumns2.default)(stateManager);
    }
  }]);

  return ColumnAdded;
}();

exports.default = ColumnAdded;

/***/ }),
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

var _cardsRepository = __webpack_require__(3);

var _cardsRepository2 = _interopRequireDefault(_cardsRepository);

var _cardRemoved = __webpack_require__(10);

var _cardRemoved2 = _interopRequireDefault(_cardRemoved);

var _repositionAllColumns = __webpack_require__(11);

var _repositionAllColumns2 = _interopRequireDefault(_repositionAllColumns);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ColumnRemoved = function () {
  function ColumnRemoved() {
    _classCallCheck(this, ColumnRemoved);
  }

  _createClass(ColumnRemoved, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.columnRemovedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      this.stateManager = stateManager;

      var column = this.stateManager.objectData('columns', event.data.columnId);
      if (!column) return;

      this.removeAllCards(column);
      this.removeColumn(column);
      (0, _repositionAllColumns2.default)(this.stateManager);
    }

    // private

  }, {
    key: 'removeAllCards',
    value: function removeAllCards(column) {
      var _this = this;

      var cardRemovedEventHandler = new _cardRemoved2.default();
      var cardsRepo = new _cardsRepository2.default(this.stateManager);

      cardsRepo.cardsByColumn(column.id).forEach(function (card) {
        var proxyEvent = (0, _eventDefinitions.cardRemovedEvent)('proxyRequester', card.id);
        cardRemovedEventHandler.execute({
          stateManager: _this.stateManager,
          event: proxyEvent
        });
      });
    }
  }, {
    key: 'removeColumn',
    value: function removeColumn(column) {
      this.stateManager.removeObject('columns', column.id);
    }
  }]);

  return ColumnRemoved;
}();

exports.default = ColumnRemoved;

/***/ }),
/* 33 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ColumnUpdated = function () {
  function ColumnUpdated() {
    _classCallCheck(this, ColumnUpdated);
  }

  _createClass(ColumnUpdated, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.columnUpdatedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      this.stateManager = stateManager;

      var _event$data = event.data,
          columnId = _event$data.columnId,
          changes = _event$data.changes;

      var column = this.stateManager.objectData('columns', columnId);
      if (!column) return;

      var newPosition = changes.position;

      if (newPosition !== undefined) {
        this.updatePositionOfOtherColumns(column, newPosition);
      }
      this.stateManager.updateObject('columns', columnId, changes);
    }

    // private

  }, {
    key: 'updatePositionOfOtherColumns',
    value: function updatePositionOfOtherColumns(movedColumn, newPosition) {
      var _this = this;

      var movedColumnId = movedColumn.id;
      var oldPosition = movedColumn.position;
      var columns = this.stateManager.bucket('columns').filter(function (c) {
        return c.id !== movedColumnId;
      });

      if (newPosition < oldPosition) {
        // moving to left
        // all after movedColumnId's newPosition: update position +1
        columns.forEach(function (c) {
          if (c.position >= newPosition && c.position < oldPosition) {
            _this.stateManager.updateObject('columns', c.id, { position: c.position + 1 });
          }
        });
      } else {
        // moving to right
        // all before movedColumnId's newPosition: update position -1
        columns.forEach(function (c) {
          if (c.position <= newPosition && c.position > oldPosition) {
            _this.stateManager.updateObject('columns', c.id, { position: c.position - 1 });
          }
        });
      }
    }
  }]);

  return ColumnUpdated;
}();

exports.default = ColumnUpdated;

/***/ }),
/* 34 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CommentAdded = function () {
  function CommentAdded() {
    _classCallCheck(this, CommentAdded);
  }

  _createClass(CommentAdded, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.commentAddedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      var card = stateManager.objectData('cards', event.data.cardId);
      if (!card) return;

      var eventData = event.data;
      eventData.createdAt = event.createdAt || event.data.createdAt;

      stateManager.addObject('comments', eventData);
    }
  }]);

  return CommentAdded;
}();

exports.default = CommentAdded;

/***/ }),
/* 35 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CommentRemoved = function () {
  function CommentRemoved() {
    _classCallCheck(this, CommentRemoved);
  }

  _createClass(CommentRemoved, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.commentRemovedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;
      var commentId = event.data.commentId;

      stateManager.removeObject('comments', commentId);
    }
  }]);

  return CommentRemoved;
}();

exports.default = CommentRemoved;

/***/ }),
/* 36 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SettingsUpdated = function () {
  function SettingsUpdated() {
    _classCallCheck(this, SettingsUpdated);
  }

  _createClass(SettingsUpdated, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.settingsUpdatedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      var data = event.data;
      var settings = stateManager.objectData('settings', data.id);
      if (settings) {
        stateManager.removeObject('settings', data.id);
      }

      if (data.value) {
        stateManager.addObject('settings', event.data);
      }
    }
  }]);

  return SettingsUpdated;
}();

exports.default = SettingsUpdated;

/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var UserUpdated = function () {
  function UserUpdated() {
    _classCallCheck(this, UserUpdated);
  }

  _createClass(UserUpdated, [{
    key: 'forEvent',
    value: function forEvent() {
      return _eventDefinitions.userUpdatedEventType;
    }
  }, {
    key: 'execute',
    value: function execute(_ref) {
      var stateManager = _ref.stateManager,
          event = _ref.event;

      var data = event.data;
      var existedUser = stateManager.objectData('users', data.id);
      var userData = existedUser || {};

      userData[data.key] = data.value;
      userData.id = data.id;

      if (existedUser) {
        stateManager.updateObject('users', data.id, userData);
      } else {
        stateManager.addObject('users', userData);
      }
    }
  }]);

  return UserUpdated;
}();

exports.default = UserUpdated;

/***/ }),
/* 38 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utils = __webpack_require__(1);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SendFileUsecase = function () {
  function SendFileUsecase() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, SendFileUsecase);

    this.filesStorage = params.filesStorage || (0, _utils.hasToBeSet)('filesStorage');
  }

  _createClass(SendFileUsecase, [{
    key: 'sendResponse',
    value: function sendResponse(params) {
      var fileName = params.fileName,
          expressResponse = params.expressResponse;

      var fileUrl = this.filesStorage.fileUrl(fileName);
      if (this.isLocal(fileUrl)) {
        expressResponse.sendFile(fileName, {
          dotfiles: 'deny',
          root: this.filesStorage.rootPath()
        });
      } else {
        expressResponse.redirect(fileUrl);
      }
    }

    // private

  }, {
    key: 'isLocal',
    value: function isLocal(fileUrl) {
      return fileUrl[0] === '/';
    }
  }]);

  return SendFileUsecase;
}();

exports.default = SendFileUsecase;

/***/ }),
/* 39 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utils = __webpack_require__(1);

var _eventDefinitions = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StoreFileUsecase = function () {
  function StoreFileUsecase() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, StoreFileUsecase);

    this.filesStorage = params.filesStorage || (0, _utils.hasToBeSet)('filesStorage');
    this.eventStorage = params.eventStorage || (0, _utils.hasToBeSet)('eventStorage');
    this.fileAddingRequester = 'Starboard BOT';
  }

  _createClass(StoreFileUsecase, [{
    key: 'addFile',
    value: function addFile(multerFile) {
      var _this = this;

      var originalFileName = multerFile.originalname;
      var originalFilePath = multerFile.path;

      return this.filesStorage.addFile({
        fileName: originalFileName,
        filePath: originalFilePath
      }).then(function (fileName) {
        return '/attachments/' + fileName;
      }).then(function (fileUrl) {
        _this.eventStorage.addEvent((0, _eventDefinitions.fileAddedEvent)(_this.fileAddingRequester, fileUrl));
        return fileUrl;
      });
    }
  }]);

  return StoreFileUsecase;
}();

exports.default = StoreFileUsecase;

/***/ }),
/* 40 */
/***/ (function(module, exports) {

module.exports = require("body-parser");

/***/ }),
/* 41 */
/***/ (function(module, exports) {

module.exports = require("child_process");

/***/ }),
/* 42 */
/***/ (function(module, exports) {

module.exports = require("crypto");

/***/ }),
/* 43 */
/***/ (function(module, exports) {

module.exports = require("express");

/***/ }),
/* 44 */
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ }),
/* 45 */
/***/ (function(module, exports) {

module.exports = require("mkdirp");

/***/ }),
/* 46 */
/***/ (function(module, exports) {

module.exports = require("multer");

/***/ }),
/* 47 */
/***/ (function(module, exports) {

module.exports = require("socket.io");

/***/ }),
/* 48 */
/***/ (function(module, exports) {

module.exports = require("socket.io-client");

/***/ })
/******/ ]);
});